<?php
  // Filename: artikel_def.php
  //
  // Modul: Definitions
  //
  // Autoren: Jos Fontanil & Reto Glanzmann
  //
  // Zweck: Definiert die Klasse Artikel
  //
  // Sicherheitsstatus:                 *** USER ***
  //
  // Version: 1.1
  //
  // CVS-Version / Datum: $Id: artikel_def.php,v 1.12 2002/01/24 23:32:00 fontajos Exp $
  //
  // -----------------------------------------------------------------------
  //
  // Lizenz
  // ======
  // PhPepperShop Shopsystem
  // Copyright (C) 2001  Reto Glanzmann, Jos Fontanil
  //
  // This program is free software; you can redistribute it and/or modify
  // it under the terms of the GNU General Public License as published by
  // the Free Software Foundation; either version 2 of the License, or
  // (at your option) any later version.
  //
  // This program is distributed in the hope that it will be useful,
  // but WITHOUT ANY WARRANTY; without even the implied warranty of
  // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  // GNU General Public License for more details.
  //
  // You should have received a copy of the GNU General Public License
  // along with this program; if not, write to the Free Software
  // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  //
  // -----------------------------------------------------------------------
  // Damit jedes andere Modul ueberpruefen kann ob dieses hier schon "included" ist
  // wird folgende Vairable auf true gesetzt (Name = Name des Moduls ohne .php)
  $artikel_def = true;

  // -----------------------------------------------------------------------
  // Definition eines Artikel-Objekts:
  class Artikel {
      var $artikel_ID;
      var $artikel_Nr;
      var $name;
      var $beschreibung;
      var $letzteAenderung;
      var $gewicht;
      var $preis;
      var $aktionspreis;
      var $link;
      var $bild_gross;
      var $bild_klein;
      var $bildtyp;
      var $bild_last_modified;
      var $aktionspreis_verwenden;
      var $optionen = array();
      var $variationen = array();

      //Konstruktor
      function Artikel() {
      }

      //putoption legt eine Option eines Artikels im internen Array ab
      function putoption($cle, $wert){
          $this->optionen[$cle] = $wert;
      }

      //getalloptionen liefert in einem assoz. Array alle Optionen zurck
      function getalloptionen(){
          $optpaar = array();
          foreach(($this->optionen) as $keyname => $value){
              $optpaar[$keyname] = $value;
          }
          return $optpaar;
      }
      //optionenanzahl liefert die Anzahl Elemente im Array $optionen
      function optionenanzahl(){
          return count($this->optionen);
      }

      //putvariation legt eine Option eines Artikels im internen Array ab
      function putvariation($cle, $wert){
          $this->variationen[$cle] = $wert;
      }

      //getallvariationen liefert in einem assoz. Array alle Optionen zurck
      function getallvariationen(){
          $optpaar = array();
          foreach(($this->variationen) as $keyname => $value){
              $optpaar[$keyname] = $value;
          }
          return $optpaar;
      }
      //variationenanzahl liefert die Anzahl Elemente im Array $variationen
      function variationenanzahl(){
          return count($this->variationen);
      }
  }// End class Artikel

  // -----------------------------------------------------------------------
  // Wird in gewissen Funktionen zur einfacheren Parameteruebergabe verwendet
  // Definition eines Options-Objekts:
  class Option {
      var $Optionen_Nr;
      var $Optionstext;
      var $Preisdifferenz;
      var $FK_Artikel_ID;
  }// End class Option

  // -----------------------------------------------------------------------
  // Wird in gewissen Funktionen zur einfacheren Parameteruebergabe verwendet
  // Definition eines Variations-Objekts:
  class Variation {
      var $Variations_Nr;
      var $Variationstext;
      var $Aufpreis;
      var $FK_Artikel_ID;
  }// End class Variation

  // -----------------------------------------------------------------------
  // Damit wir einen Artikel mit zugehoerigen Kategorien sinnvoll transportieren
  // koennen, haben wir diese Klasse definiert
  class Artikelmitkategorien {
      var $myArtikel;
      var $myKategorienarray = array();

      //Konstruktor
      function Artikelmitkategorien() {
          $myArtikel = new Artikel;
      }
  }// End class Artikelmitkategorien

  // End of file-----------------------------------------------------------------------
?>