<?php
  // Filename: kunde_def.php
  //
  // Modul: Definitions
  //
  // Autoren: Jos Fontanil & Reto Glanzmann
  //
  // Zweck: Definiert die Klasse Kunde
  //
  // Sicherheitsstatus:                 *** USER ***
  //
  // Version: 1.1
  //
  // CVS-Version / Datum: $Id: kunde_def.php,v 1.11 2002/01/24 23:32:00 fontajos Exp $
  //
  // -----------------------------------------------------------------------
  //
  // Lizenz
  // ======
  // PhPepperShop Shopsystem
  // Copyright (C) 2001  Reto Glanzmann, Jos Fontanil
  //
  // This program is free software; you can redistribute it and/or modify
  // it under the terms of the GNU General Public License as published by
  // the Free Software Foundation; either version 2 of the License, or
  // (at your option) any later version.
  //
  // This program is distributed in the hope that it will be useful,
  // but WITHOUT ANY WARRANTY; without even the implied warranty of
  // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  // GNU General Public License for more details.
  //
  // You should have received a copy of the GNU General Public License
  // along with this program; if not, write to the Free Software
  // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  //
  // -----------------------------------------------------------------------
  // Damit jedes andere Modul ueberpruefen kann ob dieses hier schon "included" ist
  // wird folgende Vairable auf true gesetzt (Name = Name des Moduls ohne .php)
  $kunde_def = true;

  // -----------------------------------------------------------------------
  // Definiert die Klasse Kunde, welche alle Daten eines Kunden fassen kann
  // Diese Klasse wurde vor allem dafuer ausgelegt, alle moeglichen Daten eines
  // Kunden speichern zu koennen. Wenn man nicht alle Variablen benutzt macht
  // das aber auch nichts, es sollen hiermit einfach alle Moeglichkeiten
  // abgedeckt sein.
  class Kunde {
      var $k_ID;       //Autoincrement ID von der Datenbank her
      var $Kunden_ID;  //Unique, nicht nachvollziehbare Zahl (Security, siehe newKunde(...))
      var $Kunden_Nr;  //Frei waehlbare Kunden-Nr fuer Geschaeftsprozesse
      var $Session_ID; //ist leer, wenn Kunde gerade nicht am bestellen ist
      var $Anrede;
      var $Vorname;
      var $Nachname;
      var $Firma;
      var $Abteilung;
      var $Strasse;
      var $Postfach;
      var $PLZ;
      var $Ort;
      var $Land;
      var $Tel;
      var $Fax;
      var $Email;
      var $Einkaufsvolumen;
      var $LetzteBestellung;
      var $Login;
      var $Passwort;
      var $gesperrt;
      var $temp; //bedeutet, dass dieser Kunde nur bis Bestellungs_Abschluss existiert
      var $Attribut1;//Selbstkonfigurierte Eintraege
      var $Attribut2;
      var $Attribut3;
      var $Attribut4;
      var $Attributwert1;
      var $Attributwert2;
      var $Attributwert3;
      var $Attributwert4;
      var $Bestellungsarray = array();

      //Konstruktor
      function Kunde() {
      }

      //putbestellung legt eine Bestellungs-Referenz (ID) im internen Array ab
      function putbestellung($Bestellungs_ID){
          $this->Bestellungsarray[] = $Bestellungs_ID;
      }

      //getallbestellungen liefert in einem Array alle Bestellungs_IDs zurueck
      function getallbestellungen(){
          $optpaar = array();
          foreach(($this->Bestellungsarray) as $keyname => $value){
              $optpaar[] = $value;
          }
          return $optpaar;
      }
      //bestellungsanzahl liefert die Anzahl Elemente im Array $Bestellungsarray
      function bestellungsanzahl(){
          return count($this->Bestellungsarray);
      }
  }// End class Kunde

  // End of file-----------------------------------------------------------------------
?>